#include <bits/stdc++.h>

using namespace std;
#define int long long
#define double long double

struct point {
    int x, y;

    void in() {
        cin >> x >> y;
    }

    point operator-(point o) {
        return {x - o.x, y - o.y};
    }

    int operator*(point o) {
        return x * o.x + y * o.y;
    }

    int operator%(point o) {
        return x * o.y - y * o.x;
    }

    int Sqlen() {
        return x * x + y * y;
    }

    double len() {
        return sqrtl(x * x + y * y);
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(10);
    int n;
    cin >> n;
    vector<point> xy(n);
    for (int i = 0; i < n; ++i) {
        xy[i].in();
    }
    if (n == 2) {
        cout << (xy[0] - xy[1]).len();
    } else {
        double ans = LLONG_MAX;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i == j)continue;
                int ost = 3 - i - j;
                double len = (xy[j] - xy[i]).len();
                double h = abs((xy[i] - xy[ost]) % (xy[j] - xy[ost])) / len;
                double L = (xy[j] - xy[ost]).Sqlen();
                L = sqrtl(max((double) 0, L - h * h));
                ans = min(ans, len + h + L);
            }
        }
        cout << ans;
    }
    return 0;
}