#include <bits/stdc++.h>

using namespace std;
#define int long long
#define double long double

struct point {
    int x, y;

    void in() {
        cin >> x >> y;
    }

    point operator-(point o) {
        return {x - o.x, y - o.y};
    }

    int operator*(point o) {
        return x * o.x + y * o.y;
    }

    int operator%(point o) {
        return x * o.y - y * o.x;
    }

    int Sqlen() {
        return x * x + y * y;
    }

    double len() {
        return sqrtl(x * x + y * y);
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(10);
    vector<int> fact(9, 1);
    for (int i = 2; i < 9; ++i) {
        fact[i] = fact[i - 1] * i;
    }
    int n;
    cin >> n;
    vector<point> xy(n);
    for (int i = 0; i < n; ++i) {
        xy[i].in();
    }
    if (n == 2) {
        cout << (xy[0] - xy[1]).len();
    } else {
        double ans = LLONG_MAX;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i == j)continue;
                point a = xy[j] - xy[i];
                point b = {a.y, -a.x};
                point b1 = {0, 0};
                double an = a.len();
                vector<vector<double>> dist(n, vector<double>(n, 0));
                for (int k = 0; k < n; ++k) {
                    for (int l = k + 1; l < n; ++l) {
                        double hk = (xy[i] - xy[k]) % (xy[j] - xy[k]) / a.len();
                        double hl = (xy[i] - xy[l]) % (xy[j] - xy[l]) / a.len();
                        double hk1 = (b1 - xy[k]) % (b - xy[k]) / b.len();
                        double hl1 = (b1 - xy[l]) % (b - xy[l]) / b.len();
                        dist[k][l] = dist[l][k] = abs(hk - hl) + abs(hk1 - hl1);
                    }
                }
                vector<int> ost;
                for (int k = 0; k < n; ++k) {
                    if (k != i && k != j) {
                        ost.push_back(k);
                    }
                }
                int sz = (int) ost.size();
                double min_L = INT_MAX;
                for (int k = 0; k < fact[n - 2]; ++k) {
                    for (int l = -1; l < sz; ++l) {
                        vector<int> a1, a2;
                        for (int m = 0; m <= l; ++m) {
                            a1.push_back(ost[m]);
                        }
                        for (int m = l + 1; m < sz; ++m) {
                            a2.push_back(ost[m]);
                        }
                        double L = 0;
                        int last = i;
                        for (int m = 0; m < a1.size(); ++m) {
                            L += dist[last][a1[m]];
                            last = a1[m];
                        }
                        last = j;
                        for (int m = 0; m < a2.size(); ++m) {
                            L += dist[last][a2[m]];
                            last = a2[m];
                        }
                        min_L = min(min_L, L);
                    }
                    std::next_permutation(ost.begin(), ost.end());
                }
                an += min_L;
                if (ans > an) {
                    ans = an;
                }
            }
        }
        cout << ans << "\n";
    }
    return 0;
}