#include <bits/stdc++.h>

using namespace std;
#define int long long
vector<vector<int>> g;

bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.second > b.second;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    g.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<pair<int, int>> security(k);
    for (int i = 0; i < k; ++i) {
        cin >> security[i].first >> security[i].second;
        security[i].first--;
    }
    std::sort(security.begin(), security.end(), cmp);
    vector<int> dist(n, INT_MAX);
    vector<bool> used(n, false);
    queue<int> q;
    for (int i = 0; i < k; ++i) {
        int v = security[i].first;
        int r = security[i].second;
        if (i < k - 1)r -= security[i + 1].second;
        if (r == 0) {
            dist[v] = 0;
            q.push(v);
            continue;
        }
        q.push(v);
        dist[v] = 0;
        queue<int> q1;
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            if (dist[u] == r) {
                q1.push(u);
                continue;
            }
            for (int to: g[u]) {
                if (dist[to] == INT_MAX) {
                    dist[to] = dist[u] + 1;
                    q.push(to);
                }
            }
        }
        while (!q1.empty()) {
            dist[q1.front()] = 0;
            q.push(q1.front());
            q1.pop();
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (dist[i] != INT_MAX) {
            ans.push_back(i);
        }
    }
    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i] + 1 << " ";
    }
    return 0;
}