#include <bits/stdc++.h>

using namespace std;
#define int long long
#define double long double
const double inf = 1e18;

struct point {
    int x, y;

    void in() {
        cin >> x >> y;
    }

    point operator-(point o) {
        return {x - o.x, y - o.y};
    }

    int operator*(point o) {
        return x * o.x + y * o.y;
    }

    int operator%(point o) {
        return x * o.y - y * o.x;
    }

    int Sqlen() {
        return x * x + y * y;
    }

    double len() {
        return sqrtl(x * x + y * y);
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(10);
    int n;
    cin >> n;
    vector<point> xy(n);
    for (int i = 0; i < n; ++i) {
        xy[i].in();
    }
    if (n == 2) {
        cout << (xy[0] - xy[1]).len();
    } else {
        double ans = inf;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i == j)continue;
                point a = xy[j] - xy[i];
                point b = {a.y, -a.x};
                point b1 = {0, 0};
                double an = a.len();
                vector<vector<double>> dist(n, vector<double>(n, 0));
                for (int k = 0; k < n; ++k) {
                    for (int l = k + 1; l < n; ++l) {
                        double hk = (xy[i] - xy[k]) % (xy[j] - xy[k]) / a.len();
                        double hl = (xy[i] - xy[l]) % (xy[j] - xy[l]) / a.len();
                        double hk1 = (b1 - xy[k]) % (b - xy[k]) / b.len();
                        double hl1 = (b1 - xy[l]) % (b - xy[l]) / b.len();
                        dist[k][l] = dist[l][k] = abs(hk - hl) + abs(hk1 - hl1);
                    }
                }
                double min_L = inf;
                vector<vector<double>> dp1(1 << n, vector<double>(n, inf));
                dp1[1 << i][i] = dp1[1 << j][j] = 0;
                for (int k = 0; k < (1 << n); ++k) {
                    for (int l = 0; l < n; ++l) {
                        if (k & (1 << l)) {
                            int k1 = k ^ (1 << l);
                            for (int m = 0; m < n; ++m) {
                                if ((k1 & (1 << m)) && dp1[k1][m] != inf) {
                                    dp1[k][l] = min(dp1[k][l], dp1[k1][m] + dist[m][l]);
                                }
                            }
                        }
                    }
                }
                for (int k = 0; k < (1 << n); ++k) {
                    if ((k & (1 << i)) && !(k & (1 << j))) {
                        double L = inf;
                        for (int l = 0; l < n; ++l) {
                            L = min(L, dp1[k][l]);
                        }
                        double L1 = inf;
                        for (int l = 0; l < n; ++l) {
                            L1 = min(L1, dp1[((1 << n) - 1) ^ k][l]);
                        }
                        min_L = min(min_L, L + L1);
                    }
                }
                an += min_L;
                if (ans > an) {
                    ans = an;
                }
            }
        }
        cout << ans << "\n";
    }
    return 0;
}